--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.393924923 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.405774308 +0100
@@ -8566,6 +9653,56 @@
 	}
 }
 
+static void
+mptsas_set_throttle_mtx(mptsas_t *mpt, mptsas_target_t *ptgt, int what)
+{
+	if (mpt->m_softstate & (MPTSAS_SS_QUIESCED | MPTSAS_SS_DRAINING)) {
+		return;
+	}
+
+	mutex_enter(&ptgt->m_t_mutex);
+	mptsas_set_throttle(mpt, ptgt, what);
+	mutex_exit(&ptgt->m_t_mutex);
+}
+
+/*
+ * Find all commands in the tx_waitq's for target and lun (if lun not -1),
+ * remove them from the queues and return the linked list.
+ */
+static mptsas_cmd_t *
+mptsas_strip_targetlun_from_txwqs(mptsas_t *mpt, ushort_t target, int lun)
+{
+	mptsas_cmd_t		*cmd, *clist, **tailp, **prev_tailp;
+	mptsas_tx_waitqueue_t	*txwq;
+	int			i;
+
+	clist = NULL;
+	tailp = &clist;
+
+	for (i = 0; i < NUM_TX_WAITQ; i++) {
+		txwq = &mpt->m_tx_waitq[i];
+		mutex_enter(&txwq->txwq_mutex);
+		prev_tailp = &txwq->txwq_cmdq;
+		cmd = txwq->txwq_cmdq;
+		while (cmd != NULL) {
+			if (Tgt(cmd) == target &&
+			    (lun == -1 || (Lun(cmd) == lun))) {
+				*prev_tailp = cmd->cmd_linkp;
+				*tailp = cmd;
+				tailp = &cmd->cmd_linkp;
+				cmd = cmd->cmd_linkp;
+				*tailp = NULL;
+			} else {
+				prev_tailp = &cmd->cmd_linkp;
+				cmd = cmd->cmd_linkp;
+			}
+		}
+		txwq->txwq_qtail = prev_tailp;
+		mutex_exit(&txwq->txwq_mutex);
+	}
+	return (clist);
+}
+
 /*
  * Clean up from a device reset.
  * For the case of target reset, this function clears the waitq of all
@@ -8580,9 +9717,12 @@
 	int		slot;
 	uchar_t		reason;
 	uint_t		stat;
+	hrtime_t	timestamp;
 
 	NDBG25(("mptsas_flush_target: target=%d lun=%d", target, lun));
 
+	timestamp = gethrtime();
+
 	/*
 	 * Make sure the I/O Controller has flushed all cmds
 	 * that are associated with this target for a target reset
@@ -8597,6 +9737,15 @@
 		switch (tasktype) {
 		case MPI2_SCSITASKMGMT_TASKTYPE_TARGET_RESET:
 			if (Tgt(cmd) == target) {
+				if (cmd->cmd_active_expiration <= timestamp) {
+					/*
+					 * When timeout requested, propagate
+					 * proper reason and statistics to
+					 * target drivers.
+					 */
+					reason = CMD_TIMEOUT;
+					stat |= STAT_TIMEOUT;
+				}
 				NDBG25(("mptsas_flush_target discovered non-"
 				    "NULL cmd in slot %d, tasktype 0x%x", slot,
 				    tasktype));
@@ -8612,14 +9761,16 @@
 			/*FALLTHROUGH*/
 		case MPI2_SCSITASKMGMT_TASKTYPE_LOGICAL_UNIT_RESET:
 			if ((Tgt(cmd) == target) && (Lun(cmd) == lun)) {
+				if (cmd->cmd_active_expiration <= timestamp) {
+					stat |= STAT_TIMEOUT;
+				}
 
 				NDBG25(("mptsas_flush_target discovered non-"
 				    "NULL cmd in slot %d, tasktype 0x%x", slot,
 				    tasktype));
 				mptsas_dump_cmd(mpt, cmd);
 				mptsas_remove_cmd(mpt, cmd);
-				mptsas_set_pkt_reason(mpt, cmd, reason,
-				    stat);
+				mptsas_set_pkt_reason(mpt, cmd, reason, stat);
 				mptsas_doneq_add(mpt, cmd);
 			}
 			break;
@@ -8648,21 +9799,13 @@
 			}
 			cmd = next_cmd;
 		}
-		mutex_enter(&mpt->m_tx_waitq_mutex);
-		cmd = mpt->m_tx_waitq;
+		cmd = mptsas_strip_targetlun_from_txwqs(mpt, target, -1);
 		while (cmd != NULL) {
 			next_cmd = cmd->cmd_linkp;
-			if (Tgt(cmd) == target) {
-				mptsas_tx_waitq_delete(mpt, cmd);
-				mutex_exit(&mpt->m_tx_waitq_mutex);
-				mptsas_set_pkt_reason(mpt, cmd,
-				    reason, stat);
-				mptsas_doneq_add(mpt, cmd);
-				mutex_enter(&mpt->m_tx_waitq_mutex);
-			}
+			mptsas_set_pkt_reason(mpt, cmd, reason, stat);
+			mptsas_doneq_add(mpt, cmd);
 			cmd = next_cmd;
 		}
-		mutex_exit(&mpt->m_tx_waitq_mutex);
 		break;
 	case MPI2_SCSITASKMGMT_TASKTYPE_ABRT_TASK_SET:
 		reason = CMD_ABORTED;
@@ -8679,21 +9822,13 @@
 			}
 			cmd = next_cmd;
 		}
-		mutex_enter(&mpt->m_tx_waitq_mutex);
-		cmd = mpt->m_tx_waitq;
+		cmd = mptsas_strip_targetlun_from_txwqs(mpt, target, lun);
 		while (cmd != NULL) {
 			next_cmd = cmd->cmd_linkp;
-			if ((Tgt(cmd) == target) && (Lun(cmd) == lun)) {
-				mptsas_tx_waitq_delete(mpt, cmd);
-				mutex_exit(&mpt->m_tx_waitq_mutex);
-				mptsas_set_pkt_reason(mpt, cmd,
-				    reason, stat);
-				mptsas_doneq_add(mpt, cmd);
-				mutex_enter(&mpt->m_tx_waitq_mutex);
-			}
+			mptsas_set_pkt_reason(mpt, cmd, reason, stat);
+			mptsas_doneq_add(mpt, cmd);
 			cmd = next_cmd;
 		}
-		mutex_exit(&mpt->m_tx_waitq_mutex);
 		break;
 	default:
 		mptsas_log(mpt, CE_WARN, "Unknown task management type %d.",
@@ -8710,8 +9845,8 @@
 mptsas_flush_hba(mptsas_t *mpt)
 {
 	mptsas_slots_t	*slots = mpt->m_active;
-	mptsas_cmd_t	*cmd;
-	int		slot;
+	mptsas_cmd_t	*cmd, *ncmd;
+	int		slot, i;
 
 	NDBG25(("mptsas_flush_hba"));
 
@@ -8736,9 +9871,8 @@
 			 */
 			mptsas_set_pkt_reason(mpt, cmd, CMD_RESET,
 			    STAT_BUS_RESET);
-			if ((cmd->cmd_flags & CFLAG_PASSTHRU) ||
-			    (cmd->cmd_flags & CFLAG_CONFIG) ||
-			    (cmd->cmd_flags & CFLAG_FW_DIAG)) {
+			if ((cmd->cmd_flags &
+			    (CFLAG_PASSTHRU | CFLAG_CONFIG | CFLAG_FW_DIAG))) {
 				cmd->cmd_flags |= CFLAG_FINISHED;
 				cv_broadcast(&mpt->m_passthru_cv);
 				cv_broadcast(&mpt->m_config_cv);
@@ -8774,16 +9908,22 @@
 	}
 
 	/*
-	 * Flush the tx_waitq
+	 * Flush the tx_waitqs
 	 */
-	mutex_enter(&mpt->m_tx_waitq_mutex);
-	while ((cmd = mptsas_tx_waitq_rm(mpt)) != NULL) {
-		mutex_exit(&mpt->m_tx_waitq_mutex);
-		mptsas_set_pkt_reason(mpt, cmd, CMD_RESET, STAT_BUS_RESET);
-		mptsas_doneq_add(mpt, cmd);
-		mutex_enter(&mpt->m_tx_waitq_mutex);
+	for (i = 0; i < NUM_TX_WAITQ; i++) {
+		mutex_enter(&mpt->m_tx_waitq[i].txwq_mutex);
+		cmd = mpt->m_tx_waitq[i].txwq_cmdq;
+		mpt->m_tx_waitq[i].txwq_cmdq = NULL;
+		mpt->m_tx_waitq[i].txwq_qtail = &mpt->m_tx_waitq[i].txwq_cmdq;
+		mutex_exit(&mpt->m_tx_waitq[i].txwq_mutex);
+		while (cmd != NULL) {
+			ncmd = cmd->cmd_linkp;
+			mptsas_set_pkt_reason(mpt, cmd, CMD_RESET,
+			    STAT_BUS_RESET);
+			mptsas_doneq_add(mpt, cmd);
+			cmd = ncmd;
+		}
 	}
-	mutex_exit(&mpt->m_tx_waitq_mutex);
 
 	/*
 	 * Drain the taskqs prior to reallocating resources.
@@ -8841,8 +9981,10 @@
 	NDBG22(("mptsas_setup_bus_reset_delay"));
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
+		mutex_enter(&ptgt->m_t_mutex);
 		mptsas_set_throttle(mpt, ptgt, HOLD_THROTTLE);
 		ptgt->m_reset_delay = mpt->m_scsi_reset_delay;
+		mutex_exit(&ptgt->m_t_mutex);
 	}
 
 	mptsas_start_watch_reset_delay();
@@ -8896,6 +10038,7 @@
 
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
+		mutex_enter(&ptgt->m_t_mutex);
 		if (ptgt->m_reset_delay != 0) {
 			ptgt->m_reset_delay -=
 			    MPTSAS_WATCH_RESET_DELAY_TICK;
@@ -8908,6 +10051,7 @@
 				done = -1;
 			}
 		}
+		mutex_exit(&ptgt->m_t_mutex);
 	}
 
 	if (restart > 0) {
@@ -9124,6 +10268,7 @@
 mptsas_scsi_setcap(struct scsi_address *ap, char *cap, int value, int tgtonly)
 {
 	mptsas_t	*mpt = ADDR2MPT(ap);
+	mptsas_target_t	*ptgt;
 	int		ckey;
 	int		rval = FALSE;
 
@@ -9165,9 +10310,9 @@
 		}
 		break;
 	case SCSI_CAP_TAGGED_QING:
-		mptsas_set_throttle(mpt, ((mptsas_tgt_private_t *)
-		    (ap->a_hba_tran->tran_tgt_private))->t_private,
-		    MAX_THROTTLE);
+		ptgt = ((mptsas_tgt_private_t *)
+		    (ap->a_hba_tran->tran_tgt_private))->t_private;
+		mptsas_set_throttle_mtx(mpt, ptgt, MAX_THROTTLE);
 		rval = TRUE;
 		break;
 	case SCSI_CAP_QFULL_RETRIES:
@@ -9255,7 +10400,7 @@
 /*
  * Error logging, printing, and debug print routines.
  */
-static char *mptsas_label = "mpt_sas";
+static char *mptsas_label = "mpt_sas3";
 
 /*PRINTFLIKE3*/
 void
@@ -9286,6 +10431,32 @@
 }
 
 #ifdef MPTSAS_DEBUG
+/*
+ * Use a circular buffer to log messages to private memory.
+ * No mutexes, so there is the opportunity for this to miss lines.
+ * But it's fast and does not hold up the proceedings too much.
+ */
+static char mptsas_dbglog_bufs[32][256];
+static uint32_t mptsas_dbglog_idx = 1;
+
+/*PRINTFLIKE1*/
+void
+mptsas_debug_log(char *fmt, ...)
+{
+	va_list		ap;
+	uint32_t	idx;
+
+	if (!mptsas_dbglog_idx) {
+		return;
+	}
+	idx = (mptsas_dbglog_idx++) & 0x1f;
+
+	va_start(ap, fmt);
+	(void) vsnprintf(mptsas_dbglog_bufs[idx],
+	    sizeof (mptsas_dbglog_bufs[0]), fmt, ap);
+	va_end(ap);
+}
+
 /*PRINTFLIKE1*/
 void
 mptsas_printf(char *fmt, ...)
@@ -9302,7 +10473,7 @@
 #ifdef PROM_PRINTF
 	prom_printf("%s:\t%s\n", mptsas_label, mptsas_log_buf);
 #else
-	scsi_log(dev, mptsas_label, SCSI_DEBUG, "%s\n", mptsas_log_buf);
+	scsi_log(dev, mptsas_label, CE_CONT, "!%s\n", mptsas_log_buf);
 #endif
 	mutex_exit(&mptsas_log_mutex);
 }
@@ -9374,22 +10545,32 @@
 	mutex_exit(&mptsas_global_mutex);
 }
 
+int mptsas_monitor_for_txwqs = 1;
 static void
 mptsas_watchsubr(mptsas_t *mpt)
 {
 	int		i;
 	mptsas_cmd_t	*cmd;
 	mptsas_target_t	*ptgt = NULL;
+	hrtime_t	timestamp = gethrtime();
+	boolean_t	restart_hba = B_FALSE;
 
 	ASSERT(MUTEX_HELD(&mpt->m_mutex));
 
-	NDBG30(("mptsas_watchsubr: mpt=0x%p", (void *)mpt));
+	NDBG30(("mptsas_watchsubr: mpt=0x%p, ncmds %d, nstarted %d",
+	    (void *)mpt, mpt->m_ncmds, mpt->m_ncstarted));
 
-#ifdef MPTSAS_TEST
-	if (mptsas_enable_untagged) {
-		mptsas_test_untagged++;
+	mpt->m_lncstarted = mpt->m_ncstarted;
+	if (mpt->m_txwq_thread_n != 0 && mpt->m_txwq_enabled != BLOCKED &&
+	    mptsas_monitor_for_txwqs) {
+		i = mpt->m_ncstarted/mptsas_scsi_watchdog_tick;
+		if (i > mpt->m_txwq_thread_threshold) {
+			mpt->m_txwq_enabled = TRUE;
+		} else if (i < (mpt->m_txwq_thread_threshold>>1)) {
+			mpt->m_txwq_enabled = FALSE;
+		}
 	}
-#endif
+	mpt->m_ncstarted = 0;
 
 	/*
 	 * Check for commands stuck in active slot
@@ -9397,25 +10578,18 @@
 	 */
 	for (i = 0; i <= mpt->m_active->m_n_normal; i++) {
 		if ((cmd = mpt->m_active->m_slot[i]) != NULL) {
-			if ((cmd->cmd_flags & CFLAG_CMDIOC) == 0) {
-				cmd->cmd_active_timeout -=
-				    mptsas_scsi_watchdog_tick;
-				if (cmd->cmd_active_timeout <= 0) {
+			if (cmd->cmd_active_expiration <= timestamp) {
+				if ((cmd->cmd_flags & CFLAG_CMDIOC) == 0) {
 					/*
 					 * There seems to be a command stuck
 					 * in the active slot.  Drain throttle.
 					 */
-					mptsas_set_throttle(mpt,
-					    cmd->cmd_tgt_addr,
+					ptgt = cmd->cmd_tgt_addr;
+					mptsas_set_throttle_mtx(mpt, ptgt,
 					    DRAIN_THROTTLE);
-				}
-			}
-			if ((cmd->cmd_flags & CFLAG_PASSTHRU) ||
-			    (cmd->cmd_flags & CFLAG_CONFIG) ||
-			    (cmd->cmd_flags & CFLAG_FW_DIAG)) {
-				cmd->cmd_active_timeout -=
-				    mptsas_scsi_watchdog_tick;
-				if (cmd->cmd_active_timeout <= 0) {
+				} else if (cmd->cmd_flags &
+				    (CFLAG_PASSTHRU | CFLAG_CONFIG |
+				    CFLAG_FW_DIAG)) {
 					/*
 					 * passthrough command timeout
 					 */
@@ -9431,6 +10605,7 @@
 
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
+		mutex_enter(&ptgt->m_t_mutex);
 		/*
 		 * If we were draining due to a qfull condition,
 		 * go back to full throttle.
@@ -9439,33 +10614,56 @@
 		    (ptgt->m_t_throttle > HOLD_THROTTLE) &&
 		    (ptgt->m_t_ncmds < ptgt->m_t_throttle)) {
 			mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
-			mptsas_restart_hba(mpt);
+			restart_hba = B_TRUE;
 		}
 
-		if ((ptgt->m_t_ncmds > 0) &&
-		    (ptgt->m_timebase)) {
-
-			if (ptgt->m_timebase <=
-			    mptsas_scsi_watchdog_tick) {
-				ptgt->m_timebase +=
-				    mptsas_scsi_watchdog_tick;
-				continue;
-			}
+		cmd = TAILQ_LAST(&ptgt->m_active_cmdq, mptsas_active_cmdq);
+		if (cmd != NULL) {
+			if (cmd->cmd_active_expiration <= timestamp) {
+				/*
+				 * Earliest command timeout expired.
+				 * Drain throttle.
+				 */
+				mptsas_set_throttle(mpt, ptgt, DRAIN_THROTTLE);
 
-			ptgt->m_timeout -= mptsas_scsi_watchdog_tick;
+				/*
+				 * Check for remaining commands.
+				 */
+				cmd = TAILQ_FIRST(&ptgt->m_active_cmdq);
+				if (cmd->cmd_active_expiration > timestamp) {
+					/*
+					 * Wait for remaining commands to
+					 * complete or time out.
+					 */
+					NDBG23(("command timed out, "
+					    "pending drain"));
+				} else {
+					mutex_exit(&ptgt->m_t_mutex);
 
-			if (ptgt->m_timeout < 0) {
-				mptsas_cmd_timeout(mpt, ptgt->m_devhdl);
-				continue;
-			}
+					/*
+					 * All command timeouts expired.
+					 */
+					mptsas_log(mpt, CE_NOTE,
+					    "Timeout of %d seconds "
+					    "expired with %d commands on "
+					    "target %d lun %d.",
+					    cmd->cmd_pkt->pkt_time,
+					    ptgt->m_t_ncmds,
+					    ptgt->m_devhdl, Lun(cmd));
 
-			if ((ptgt->m_timeout) <=
-			    mptsas_scsi_watchdog_tick) {
+					mptsas_cmd_timeout(mpt, ptgt);
+					continue;
+				}
+			} else if (cmd->cmd_active_expiration <= timestamp +
+			    (hrtime_t)mptsas_scsi_watchdog_tick * NANOSEC) {
 				NDBG23(("pending timeout"));
-				mptsas_set_throttle(mpt, ptgt,
-				    DRAIN_THROTTLE);
+				mptsas_set_throttle(mpt, ptgt, DRAIN_THROTTLE);
 			}
 		}
+		mutex_exit(&ptgt->m_t_mutex);
+	}
+	if (restart_hba == B_TRUE) {
+		mptsas_restart_hba(mpt);
 	}
 }
 
@@ -9473,16 +10671,29 @@
  * timeout recovery
  */
 static void
-mptsas_cmd_timeout(mptsas_t *mpt, uint16_t devhdl)
+mptsas_cmd_timeout(mptsas_t *mpt, mptsas_target_t *ptgt)
 {
+	uint16_t	devhdl;
+	uint64_t	sas_wwn;
+	uint8_t		phy;
+	char		wwn_str[MPTSAS_WWN_STRLEN];
+
+	devhdl = ptgt->m_devhdl;
+	sas_wwn = ptgt->m_addr.mta_wwn;
+	phy = ptgt->m_phynum;
+	if (sas_wwn == 0) {
+		(void) sprintf(wwn_str, "p%x", phy);
+	} else {
+		(void) sprintf(wwn_str, "w%016"PRIx64, sas_wwn);
+	}
 
 	NDBG29(("mptsas_cmd_timeout: target=%d", devhdl));
 	mptsas_log(mpt, CE_WARN, "Disconnected command timeout for "
-	    "Target %d", devhdl);
+	    "target %d %s,  enclosure %u .", devhdl, wwn_str,
+	    ptgt->m_enclosure);
 
 	/*
-	 * If the current target is not the target passed in,
-	 * try to reset that target.
+	 * Abort all outstanding commands on the device.
 	 */
 	NDBG29(("mptsas_cmd_timeout: device reset"));
 	if (mptsas_do_scsi_reset(mpt, devhdl) != TRUE) {
@@ -9531,7 +10742,7 @@
 	/* Set all the throttles to zero */
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
-		mptsas_set_throttle(mpt, ptgt, HOLD_THROTTLE);
+		mptsas_set_throttle_mtx(mpt, ptgt, HOLD_THROTTLE);
 	}
 
 	/* If there are any outstanding commands in the queue */
@@ -9546,7 +10757,8 @@
 			mpt->m_softstate &= ~MPTSAS_SS_DRAINING;
 			for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 			    ptgt = refhash_next(mpt->m_targets, ptgt)) {
-				mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
+				mptsas_set_throttle_mtx(mpt, ptgt,
+				    MAX_THROTTLE);
 			}
 			mptsas_restart_hba(mpt);
 			if (mpt->m_quiesce_timeid != 0) {
@@ -9583,7 +10795,7 @@
 	mpt->m_softstate &= ~MPTSAS_SS_QUIESCED;
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
-		mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
+		mptsas_set_throttle_mtx(mpt, ptgt, MAX_THROTTLE);
 	}
 	mptsas_restart_hba(mpt);
 	mutex_exit(&mpt->m_mutex);
@@ -9609,7 +10821,8 @@
 			 */
 			for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 			    ptgt = refhash_next(mpt->m_targets, ptgt)) {
-				mptsas_set_throttle(mpt, ptgt, HOLD_THROTTLE);
+				mptsas_set_throttle_mtx(mpt, ptgt,
+				    HOLD_THROTTLE);
 			}
 
 			mpt->m_quiesce_timeid = timeout(mptsas_ncmds_checkdrain,
@@ -9645,18 +10858,99 @@
 }
 
 static void
+mptsas_passthru_sge(ddi_acc_handle_t acc_hdl, mptsas_pt_request_t *pt,
+    pMpi2SGESimple64_t sgep)
+{
+	uint32_t		sge_flags;
+	uint32_t		data_size, dataout_size;
+	ddi_dma_cookie_t	data_cookie;
+	ddi_dma_cookie_t	dataout_cookie;
+
+	data_size = pt->data_size;
+	dataout_size = pt->dataout_size;
+	data_cookie = pt->data_cookie;
+	dataout_cookie = pt->dataout_cookie;
+
+	if (dataout_size) {
+		sge_flags = dataout_size |
+		    ((uint32_t)(MPI2_SGE_FLAGS_SIMPLE_ELEMENT |
+		    MPI2_SGE_FLAGS_END_OF_BUFFER |
+		    MPI2_SGE_FLAGS_HOST_TO_IOC |
+		    MPI2_SGE_FLAGS_64_BIT_ADDRESSING) <<
+		    MPI2_SGE_FLAGS_SHIFT);
+		ddi_put32(acc_hdl, &sgep->FlagsLength, sge_flags);
+		ddi_put32(acc_hdl, &sgep->Address.Low,
+		    (uint32_t)(dataout_cookie.dmac_laddress & 0xffffffffull));
+		ddi_put32(acc_hdl, &sgep->Address.High,
+		    (uint32_t)(dataout_cookie.dmac_laddress >> 32));
+		sgep++;
+	}
+	sge_flags = data_size;
+	sge_flags |= ((uint32_t)(MPI2_SGE_FLAGS_SIMPLE_ELEMENT |
+	    MPI2_SGE_FLAGS_LAST_ELEMENT |
+	    MPI2_SGE_FLAGS_END_OF_BUFFER |
+	    MPI2_SGE_FLAGS_END_OF_LIST |
+	    MPI2_SGE_FLAGS_64_BIT_ADDRESSING) <<
+	    MPI2_SGE_FLAGS_SHIFT);
+	if (pt->direction == MPTSAS_PASS_THRU_DIRECTION_WRITE) {
+		sge_flags |= ((uint32_t)(MPI2_SGE_FLAGS_HOST_TO_IOC) <<
+		    MPI2_SGE_FLAGS_SHIFT);
+	} else {
+		sge_flags |= ((uint32_t)(MPI2_SGE_FLAGS_IOC_TO_HOST) <<
+		    MPI2_SGE_FLAGS_SHIFT);
+	}
+	ddi_put32(acc_hdl, &sgep->FlagsLength, sge_flags);
+	ddi_put32(acc_hdl, &sgep->Address.Low,
+	    (uint32_t)(data_cookie.dmac_laddress & 0xffffffffull));
+	ddi_put32(acc_hdl, &sgep->Address.High,
+	    (uint32_t)(data_cookie.dmac_laddress >> 32));
+}
+
+static void
+mptsas_passthru_ieee_sge(ddi_acc_handle_t acc_hdl, mptsas_pt_request_t *pt,
+    pMpi2IeeeSgeSimple64_t ieeesgep)
+{
+	uint8_t			sge_flags;
+	uint32_t		data_size, dataout_size;
+	ddi_dma_cookie_t	data_cookie;
+	ddi_dma_cookie_t	dataout_cookie;
+
+	data_size = pt->data_size;
+	dataout_size = pt->dataout_size;
+	data_cookie = pt->data_cookie;
+	dataout_cookie = pt->dataout_cookie;
+
+	sge_flags = (MPI2_IEEE_SGE_FLAGS_SIMPLE_ELEMENT |
+	    MPI2_IEEE_SGE_FLAGS_SYSTEM_ADDR);
+	if (dataout_size) {
+		ddi_put32(acc_hdl, &ieeesgep->Length, dataout_size);
+		ddi_put32(acc_hdl, &ieeesgep->Address.Low,
+		    (uint32_t)(dataout_cookie.dmac_laddress &
+		    0xffffffffull));
+		ddi_put32(acc_hdl, &ieeesgep->Address.High,
+		    (uint32_t)(dataout_cookie.dmac_laddress >> 32));
+		ddi_put8(acc_hdl, &ieeesgep->Flags, sge_flags);
+		ieeesgep++;
+	}
+	sge_flags |= MPI25_IEEE_SGE_FLAGS_END_OF_LIST;
+	ddi_put32(acc_hdl, &ieeesgep->Length, data_size);
+	ddi_put32(acc_hdl, &ieeesgep->Address.Low,
+	    (uint32_t)(data_cookie.dmac_laddress & 0xffffffffull));
+	ddi_put32(acc_hdl, &ieeesgep->Address.High,
+	    (uint32_t)(data_cookie.dmac_laddress >> 32));
+	ddi_put8(acc_hdl, &ieeesgep->Flags, sge_flags);
+}
+
+static void
 mptsas_start_passthru(mptsas_t *mpt, mptsas_cmd_t *cmd)
 {
 	caddr_t			memp;
 	pMPI2RequestHeader_t	request_hdrp;
 	struct scsi_pkt		*pkt = cmd->cmd_pkt;
 	mptsas_pt_request_t	*pt = pkt->pkt_ha_private;
-	uint32_t		request_size, data_size, dataout_size;
-	uint32_t		direction;
-	ddi_dma_cookie_t	data_cookie;
-	ddi_dma_cookie_t	dataout_cookie;
-	uint32_t		request_desc_low, request_desc_high = 0;
-	uint32_t		i, sense_bufp;
+	uint32_t		request_size;
+	uint64_t		request_desc = 0;
+	uint64_t		sense_bufp;
 	uint8_t			desc_type;
 	uint8_t			*request, function;
 	ddi_dma_handle_t	dma_hdl = mpt->m_dma_req_frame_hdl;
@@ -9665,12 +10959,7 @@
 	desc_type = MPI2_REQ_DESCRIPT_FLAGS_DEFAULT_TYPE;
 
 	request = pt->request;
-	direction = pt->direction;
 	request_size = pt->request_size;
-	data_size = pt->data_size;
-	dataout_size = pt->dataout_size;
-	data_cookie = pt->data_cookie;
-	dataout_cookie = pt->dataout_cookie;
 
 	/*
 	 * Store the passthrough message in memory location
@@ -9680,54 +10969,24 @@
 	request_hdrp = (pMPI2RequestHeader_t)memp;
 	bzero(memp, mpt->m_req_frame_size);
 
-	for (i = 0; i < request_size; i++) {
-		bcopy(request + i, memp + i, 1);
-	}
+	bcopy(request, memp, request_size);
 
-	if (data_size || dataout_size) {
-		pMpi2SGESimple64_t	sgep;
-		uint32_t		sge_flags;
-
-		sgep = (pMpi2SGESimple64_t)((uint8_t *)request_hdrp +
-		    request_size);
-		if (dataout_size) {
-
-			sge_flags = dataout_size |
-			    ((uint32_t)(MPI2_SGE_FLAGS_SIMPLE_ELEMENT |
-			    MPI2_SGE_FLAGS_END_OF_BUFFER |
-			    MPI2_SGE_FLAGS_HOST_TO_IOC |
-			    MPI2_SGE_FLAGS_64_BIT_ADDRESSING) <<
-			    MPI2_SGE_FLAGS_SHIFT);
-			ddi_put32(acc_hdl, &sgep->FlagsLength, sge_flags);
-			ddi_put32(acc_hdl, &sgep->Address.Low,
-			    (uint32_t)(dataout_cookie.dmac_laddress &
-			    0xffffffffull));
-			ddi_put32(acc_hdl, &sgep->Address.High,
-			    (uint32_t)(dataout_cookie.dmac_laddress
-			    >> 32));
-			sgep++;
-		}
-		sge_flags = data_size;
-		sge_flags |= ((uint32_t)(MPI2_SGE_FLAGS_SIMPLE_ELEMENT |
-		    MPI2_SGE_FLAGS_LAST_ELEMENT |
-		    MPI2_SGE_FLAGS_END_OF_BUFFER |
-		    MPI2_SGE_FLAGS_END_OF_LIST |
-		    MPI2_SGE_FLAGS_64_BIT_ADDRESSING) <<
-		    MPI2_SGE_FLAGS_SHIFT);
-		if (direction == MPTSAS_PASS_THRU_DIRECTION_WRITE) {
-			sge_flags |= ((uint32_t)(MPI2_SGE_FLAGS_HOST_TO_IOC) <<
-			    MPI2_SGE_FLAGS_SHIFT);
-		} else {
-			sge_flags |= ((uint32_t)(MPI2_SGE_FLAGS_IOC_TO_HOST) <<
-			    MPI2_SGE_FLAGS_SHIFT);
-		}
-		ddi_put32(acc_hdl, &sgep->FlagsLength,
-		    sge_flags);
-		ddi_put32(acc_hdl, &sgep->Address.Low,
-		    (uint32_t)(data_cookie.dmac_laddress &
-		    0xffffffffull));
-		ddi_put32(acc_hdl, &sgep->Address.High,
-		    (uint32_t)(data_cookie.dmac_laddress >> 32));
+	NDBG15(("mptsas_start_passthru: Func 0x%x, MsgFlags 0x%x, "
+	    "size=%d, in %d, out %d", request_hdrp->Function,
+	    request_hdrp->MsgFlags, request_size,
+	    pt->data_size, pt->dataout_size));
+
+	/*
+	 * Add an SGE, even if the length is zero.
+	 */
+	if (mpt->m_MPI25 && pt->simple == 0) {
+		mptsas_passthru_ieee_sge(acc_hdl, pt,
+		    (pMpi2IeeeSgeSimple64_t)
+		    ((uint8_t *)request_hdrp + pt->sgl_offset));
+	} else {
+		mptsas_passthru_sge(acc_hdl, pt,
+		    (pMpi2SGESimple64_t)
+		    ((uint8_t *)request_hdrp + pt->sgl_offset));
 	}
 
 	function = request_hdrp->Function;
@@ -9735,6 +10994,7 @@
 	    (function == MPI2_FUNCTION_RAID_SCSI_IO_PASSTHROUGH)) {
 		pMpi2SCSIIORequest_t	scsi_io_req;
 
+		NDBG15(("mptsas_start_passthru: Is SCSI IO Req"));
 		scsi_io_req = (pMpi2SCSIIORequest_t)request_hdrp;
 		/*
 		 * Put SGE for data and data_out buffer at the end of
@@ -9746,8 +11006,8 @@
 		    &scsi_io_req->SenseBufferLength,
 		    (uint8_t)(request_size - 64));
 
-		sense_bufp = mpt->m_req_frame_dma_addr +
-		    (mpt->m_req_frame_size * cmd->cmd_slot);
+		sense_bufp = (uint32_t)(mpt->m_req_frame_dma_addr +
+		    (mpt->m_req_frame_size * cmd->cmd_slot) & 0xffffffffull);
 		sense_bufp += 64;
 		ddi_put32(acc_hdl,
 		    &scsi_io_req->SenseBufferLowAddress, sense_bufp);
@@ -9765,8 +11025,8 @@
 		 */
 		if (function == MPI2_FUNCTION_SCSI_IO_REQUEST) {
 			desc_type = MPI2_REQ_DESCRIPT_FLAGS_SCSI_IO;
-			request_desc_high = (ddi_get16(acc_hdl,
-			    &scsi_io_req->DevHandle) << 16);
+			request_desc = (((uint64_t)ddi_get16(acc_hdl,
+			    &scsi_io_req->DevHandle)) << 48);
 		}
 	}
 
